Subject: Re: [PATCH block/for-3.3/core] block: an exiting task should be allowed to create io_context

From: Tejun Heo <[email-masked]>
Date: Wed, 4 Jan 2012 17:24:45 -0800

Hello, again.

On Tue, Jan 03, 2012 at 02:35:05PM -0800, Tejun Heo wrote:
> > Hmmm... I disabled cfqq merge logic (commented out
> > cfq_close_cooperator() and the following cfq_setup_merge() calls) in
> > cfq_select_queue() and neither is triggering for quite a while now.
> > Maybe cfqq refcnt is getting borked over cfqq merging / splitting?  It
> > would also explain the low frequency of the issue too.  I'll try to
> > further isolate it but It would be awesome if someone more familiar
> > with the logic can go over that part.
> 
> Scrap that.  It triggered and yeah cfq_get_next_queue() is retrieving
> empty cfqq from the service tree.

Update: I've been running with ELEVATOR_INSERT_SORT_MERGE disabled and
none of the issues triggered for about three hours now.  It usually
triggers under an hour.

Hugh, can you please verify whether the patch appended at the end
makes the problem go away?

Thanks.

diff --git a/block/elevator.c b/block/elevator.c
index 99838f4..2e172d2 100644
--- a/block/elevator.c
+++ b/block/elevator.c
@@ -644,6 +644,9 @@ void __elv_add_request(struct request_queue *q, struct request *rq, int where)
 
 	rq->q = q;
 
+	if (where == ELEVATOR_INSERT_SORT_MERGE)
+		where = ELEVATOR_INSERT_SORT;
+
 	if (rq->cmd_flags & REQ_SOFTBARRIER) {
 		/* barriers are scheduling boundary, update end_sector */
 		if (rq->cmd_type == REQ_TYPE_FS ||